/* Written by Morgoth DBMA, morgothdbma@o2.pl
 This is part of PgXexplorer software, Open Source
 on BSD licence, Libraries(interaces) used:
 GNU GCC, AS (all stuff needed to compile C source into executable binary)
 LibPQ-FE from PostgreSQL, GTK (GIMP Toolkit)
 written in VIM editor, ctags used, CVS used
 Currently only one author: MOrgoth DBMA
 ! THIS FILE IS BASED ON GTK EXAMPLE FROM INTERNET !
 ! MANY GTK UI FUNCTIONS ARE BASED ON SOMEBODY'S EXAMLE CODE !
 ! BUT I DON'T KNOW THEIR PERSONALITY SO SORRY !
 ! I CANNOT ADD THEM TO AUTORS, BUT THANKS FOR SUPPORT ME !
 FILE: entireDB.h */
#include "common.h"
#include "entireDB.h"
extern struct main_components components;
extern int connected;
extern PGconn* connection;
extern int want_all_elems;
extern int max_tabs;

GtkWidget* construct_view_table(char* tabname)
{
 char*** ptr;
 int row,col;
 char errstr[MAX_QUERY_LENGTH+100];
 struct result_cache res_cache;
 int i,j,orow,ocol;
 GtkWidget*** table_entry;
 GtkWidget* table_view;
 GtkWidget* scroller_view;
 debug("%s:%d",__FILE__,__LINE__);
 if (!connection) { error("no_connection %s:%d", __FILE__,__LINE__); return NULL; }
 execute_printf(connection, &ptr, &row, &col, errstr, 1, "SELECT * FROM %s", tabname);
 if (row<0 || col<0) { debug("errstr=%s", errstr); return NULL;	} /* FIXME SHOULDN'T BE THERE DIALOG ?? */
 res_cache.cols = col;
 res_cache.rows = row;
 res_cache.data = ptr;
 table_entry = (GtkWidget***)malloc(row*sizeof(GtkWidget**));
 for (i=0;i<row;i++) table_entry[i] = (GtkWidget**)malloc(col*sizeof(GtkWidget*));
 orow=row;
 ocol=col;
 if (col>32 || row>256)
   {
    if (row>256) col = (col>8 )?8 :col;
    else if (row>128)  col = (col>16 )?16 :col;
    else if (row>64)  col = (col>32 )?32 :col;
    else             col = (col>48)?48:col;
    row = (row>256)?256:row;
    col = (col>256)?256:col;
   }
 debug("row=%d, col=%d\n",row,col);
 table_view = gtk_table_new(row, col, FALSE);
 for (i=0;i<row;i++)
 for (j=0;j<col;j++)
   {
    table_entry[i][j] = gtk_entry_new();
    gtk_entry_set_text(GTK_ENTRY(table_entry[i][j]), ptr[i][j]);
    gtk_entry_set_editable(GTK_ENTRY(table_entry[i][j]), FALSE);
    gtk_table_attach (GTK_TABLE (table_view), table_entry[i][j], j, j+1, i, i+1,GTK_FILL,GTK_FILL, 0, 0);
    gtk_widget_show(table_entry[i][j]);
   }
 gtk_widget_show(table_view);
 scroller_view = gtk_scrolled_window_new(NULL,NULL);
 gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroller_view), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroller_view), table_view);
 gtk_container_set_border_width(GTK_CONTAINER(scroller_view), 1);
 gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(scroller_view), GTK_CORNER_TOP_RIGHT);
 gtk_widget_show(scroller_view);
 free_p3c(&ptr, orow, ocol);
 return scroller_view;
}

int drop_control(GtkWidget* w, gpointer data)
{
 gtk_main_quit();
 return FALSE;
}

void rotate_book(GtkButton *button,GtkNotebook *notebook)
{
 gtk_notebook_set_tab_pos(notebook,(notebook->tab_pos+1)%4);
}

void tabsborder_book(GtkButton *button,GtkNotebook *notebook)
{
 int tval = FALSE;
 int bval = FALSE;
 if (notebook->show_tabs == 0)   tval = TRUE; 
 if (notebook->show_border == 0) bval = TRUE;
 gtk_notebook_set_show_tabs (notebook, tval);
 gtk_notebook_set_show_border (notebook, bval);
}

void cmenu_browse_all(GtkWidget* w, gpointer data)
{
 GtkWidget *window;
 GtkWidget *button;
 GtkWidget *table;
 GtkWidget *notebook;
 GtkWidget *frame;
 GtkWidget *label;
 GtkWidget *scroller; 
 GtkWidget *vtable;
 char** tables;
 int ntabs;
 int i;
 debug("%s:%d",__FILE__,__LINE__);
 if (!connected)  { gtk_dialog_printf("Not connected to DB!"); return; }
 if (!get_db_tables(connection,&tables, &ntabs, want_all_elems)) { gtk_dialog_printf("Cannot get DB tables list!\n"); return; }
/* for (i=0;i<ntabs;i++) printf("%s\n\n", tables[i]);*/
 
 window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
 gtk_window_set_modal(GTK_WINDOW(window), TRUE);
 gtk_widget_set_usize(window, 800,600);
 gtk_window_set_title (GTK_WINDOW(window), "Preview of DB, (results will be truncated if too long) wait...");
 
 table = gtk_table_new(8,10,FALSE);
 
 notebook = gtk_notebook_new();
 gtk_notebook_set_tab_pos(GTK_NOTEBOOK (notebook), GTK_POS_TOP);
 
 scroller = gtk_scrolled_window_new(NULL,NULL);
 gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroller), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroller), notebook);
 gtk_container_set_border_width(GTK_CONTAINER(scroller), 2);
 gtk_widget_show(scroller);
 
 gtk_container_set_border_width (GTK_CONTAINER (window), 1);

 gtk_table_attach(GTK_TABLE(table), scroller, 0,8,0,9, GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0);
 gtk_widget_show(notebook);
 
 gtk_signal_connect (GTK_OBJECT (window), "delete_event",GTK_SIGNAL_FUNC(drop_control), (gpointer)(window));
 gtk_container_add (GTK_CONTAINER(window), table);
 if (ntabs>max_tabs) ntabs=max_tabs;
 for (i=0;i<ntabs;i++)
     {
      debug("TABLES[%d] = %s\n", i, tables[i]);
      frame = gtk_frame_new (tables[i]);
      
      gtk_container_set_border_width (GTK_CONTAINER(frame),2);
      
      gtk_widget_set_usize (frame, 100, 25);
      gtk_widget_show(frame);
      
      label = gtk_label_new(tables[i]);
      gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, label);

      vtable = construct_view_table(tables[i]);
      if (vtable) gtk_container_add(GTK_CONTAINER(frame), construct_view_table(tables[i]));
      else gtk_container_add(GTK_CONTAINER(frame), gtk_label_new("Connot read table!"));
    }
/* gtk_notebook_set_page (GTK_NOTEBOOK(notebook), 3);*/
 button = gtk_button_new_with_label ("Close");
 gtk_signal_connect_object (GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC (drop_control), NULL);
 gtk_table_attach(GTK_TABLE(table), button, 0,1,9,10,GTK_FILL|GTK_EXPAND,GTK_FILL,0,0);
 gtk_widget_show(button);
 button = gtk_button_new_with_label ("Next Table");
 gtk_signal_connect_object (GTK_OBJECT (button), "clicked",(GtkSignalFunc)gtk_notebook_next_page,GTK_OBJECT (notebook));
 gtk_table_attach(GTK_TABLE(table), button, 1,2,9,10,GTK_FILL|GTK_EXPAND,GTK_FILL,0,0);
 gtk_widget_show(button);
 button = gtk_button_new_with_label ("Previous Table");
 gtk_signal_connect_object (GTK_OBJECT (button), "clicked",(GtkSignalFunc)gtk_notebook_prev_page,GTK_OBJECT (notebook));
 gtk_table_attach(GTK_TABLE(table), button, 2,3,9,10,GTK_FILL|GTK_EXPAND,GTK_FILL,0,0);
 gtk_widget_show(button);
 button = gtk_button_new_with_label ("Tab Position");
 gtk_signal_connect (GTK_OBJECT (button), "clicked",(GtkSignalFunc)rotate_book,GTK_OBJECT(notebook));
 gtk_table_attach(GTK_TABLE(table), button, 3,4,9,10,GTK_FILL|GTK_EXPAND,GTK_FILL,0,0);
 gtk_widget_show(button);
 button = gtk_button_new_with_label ("Border on/off");
 gtk_signal_connect (GTK_OBJECT (button), "clicked",(GtkSignalFunc)tabsborder_book,GTK_OBJECT (notebook));
 gtk_table_attach(GTK_TABLE(table), button, 4,5,9,10,GTK_FILL|GTK_EXPAND,GTK_FILL,0,0);
 gtk_widget_show(button);
 button = gtk_button_new_with_label("remove page");
/* gtk_signal_connect(GTK_OBJECT (button), "clicked",(GtkSignalFunc) remove_book,GTK_OBJECT(notebook));*/
 gtk_table_attach(GTK_TABLE(table), button, 5,6,9,10,GTK_FILL|GTK_EXPAND,GTK_FILL,0,0);
 gtk_widget_show(button);
 gtk_widget_show(table);
 gtk_widget_show(window);
 gtk_window_set_title (GTK_WINDOW(window), "Preview of DB");
 gtk_main();
 if (GTK_IS_WIDGET(window)) gtk_widget_destroy(window);
 for (i=0;i<ntabs;i++) if (tables[i]) { free(tables[i]); tables[i]=NULL; }
 if (tables) { free(tables); tables=NULL; }
}
